const { PAPI } = require(`../../GMLIB-LegacyRemoteCallApi/lib/BEPlaceholderAPI-JS`);

const BossBar = new JsonConfigFile("./plugins/Elysium/config/BossBar.json")
const data = BossBar.init("data", {});

const conf = new JsonConfigFile("./plugins/Elysium/config/config.json")
const config = conf.init("config", {});

let lang = config.语言;

const LANG = new JsonConfigFile(`./plugins/Elysium/Lang/${lang}.json`)
const Lang = LANG.init("LANG", {});

let ORI_ERROR = Lang.ori_error,
    BOSSBAR_COMMAND = Lang.bossbar_command,
    BOSSBAR_ON_MENU = Lang.bossbar_on_menu,
    BOSSBAR_OFF_MENU = Lang.bossbar_off_menu,
    BOSSBAR_ON = Lang.bossbar_on,
    BOSSBAR_OFF = Lang.bossbar_off,
    BOSSBAR_RELOAD_MENU = Lang.bossbar_reload_menu;

let BossBarinterval = config.BossBar刷新间隔;
let i = 0;


mc.listen("onServerStarted", function () {
    const BOSSBAR = mc.newCommand("bossbar", `${BOSSBAR_COMMAND}`, PermType.Any)
    BOSSBAR.setEnum("BossBar", ["on", "off", "reload"]);
    BOSSBAR.optional("BossBar", ParamType.Enum, "BossBar", 1);
    BOSSBAR.overload(["BossBar"]);
    BOSSBAR.setCallback(function (_cmd, ori, out, res) {
        if (!ori.player) return out.error(ORI_ERROR);
        if (res.BossBar != undefined) {
            if (res.BossBar == "on") {
                pla.addTag("BossBar");
                ori.player.tell(`${BOSSBAR_ON}`);
            }
            else if (res.BossBar == "off") {
                pla.removeTag("BossBar");
                player.removeBossBar(1);
                ori.player.tell(`${BOSSBAR_OFF}`);
            }
            else if (res.BossBar == "reload") {
                BossBar.reload;
                ori.player.tell(`${BOSSBAR_RELOAD_MENU}`);
                return;
            }
        };
        if (res.BossBar == undefined) {
            menu(ori.player);
        }
    })
    BOSSBAR.setup();
})

var PROMPT = {
    ON: `${BOSSBAR_ON_MENU}`,
    OFF: `${BOSSBAR_OFF_MENU}`,
    RELOAD: `${BOSSBAR_RELOAD_MENU}`,
}

function menu(player) {
    var fm = mc.newSimpleForm();
    fm.setTitle("BossBar");
    fm.addButton(PROMPT.ON, "textures/ui/mute_off.png");
    fm.addButton(PROMPT.OFF, "textures/ui/mute_on.png");
    if (player.isOP()) {
        fm.addButton(PROMPT.RELOAD, "textures/ui/book_shiftleft_hover.png");
    }
    player.sendForm(fm,
        function (pla, data) {
            switch (data) {
                case 0:
                    pla.addTag("BossBar");
                    pla.tell(`${BOSSBAR_ON}`);
                    break;
                case 1:
                    pla.removeTag("BossBar");
                    player.removeBossBar(1);
                    pla.tell(`${BOSSBAR_OFF}`);
                    break;
                case 2:
                    BossBar.reload;
                    pla.tell(`${BOSSBAR_RELOAD_MENU}`);
            }
        }
    );
}

function Entitys() {
    let Entity = {
        mob: 0,
        item: 0
    };
    let Entitys = mc.getAllEntities();
    if (Entitys.length > 0) {
        Entitys.forEach(entitys => {
            entitys.isItemEntity() ? Entity.item++ : Entity.mob++;
        });
    };
    return Entity;
}

setInterval(() => {
    let pls = mc.getOnlinePlayers();
    for (let x in pls) {
        let player = pls[x];
        if (player.hasTag("BossBar") === false) {
            return;
        }
        let objectTexts = [];
        for (let key in data) {
            if (data[key] && data[key]) {
                objectTexts.push(data[key]);
            }
        }
        i = ++i % objectTexts.length;
        let Entity = Entitys();
        let plDevice = player.getDevice()
        let player_ping = plDevice.avgPing
        let player_ip = plDevice.ip;
        let strObj = JSON.stringify(objectTexts[i])
            .replace(/\{player_realname}/g, player.realName)
            .replace(/\{player_uuid}/g, player.uuid)
            .replace(/\{player_xuid}/g, player.xuid)
            .replace(/\{player_ping}/g, player_ping)
            .replace(/\{player_health}/g, player.health)
            .replace(/\{player_max_health}/g, player.maxHealth)
            .replace(/\{player_gamemode}/g, player.gameMode)
            .replace(/\{player_x}/g, player.pos.x)
            .replace(/\{player_y}/g, player.pos.y)
            .replace(/\{player_z}/g, player.pos.z)
            .replace(/\{player_is_op}/g, player.isOP())
            .replace(/\{player_ip}/g, player_ip)
            .replace(/\{player_language}/g, player.langCode)
            .replace(/\{player_level}/g, player.level)
            .replace(/\{item}/g, Entity.item)
            .replace(/\{mob}/g, Entity.mob)
        let obj = JSON.parse(strObj);
        player.removeBossBar(1);
        player.setBossBar(1, `${obj}`, 100, i);
    }
}, BossBarinterval * 1000)