const conf = new JsonConfigFile("./plugins/Elysium/config/config.json")
const config = conf.init("config", {});

let lang = config.语言;

const LANG = new JsonConfigFile(`./plugins/Elysium/Lang/${lang}.json`)
const Lang = LANG.init("LANG", {});

let ORI_ERROR = Lang.ori_error,
    MENU_COMMAND = Lang.menu,
    MINE = Lang.mine,
    GAME = Lang.game,
    SERVER = Lang.server,
    THE_END = Lang.the_end,
    TRAITBLOCK = Lang.traitblock,
    SIGN_MENU = Lang.sign_menu,
    SERVER_FILES = Lang.server_files,
    THE_MAIN_CITY = Lang.the_main_city,
    CNMAP = Lang.cnmap,
    COURSE_OF_STUDY = Lang.course_of_study,
    END_LAND = Lang.end_land,
    OTHER_SERVER = Lang.other_server,
    GAMES = Lang.games,
    GO_MINE = Lang.go_mine,
    GO_BACK = Lang.go_back,
    LAND = Lang.land,
    PVP = Lang.pvp,
    PARKOUR = Lang.parkour,
    EMPTY_ISLAND_WAR = Lang.empty_island_war,
    PRIVATE_LAND = Lang.private_land,
    DISPALY_LAND = Lang.display_land,
    RCCBEC = Lang.rccbec,
    RCCBES = Lang.rccbes,
    RCCJEC = Lang.rccjec,
    RCCJES = Lang.rccjes,
    PLUGIN_PROMPTS = Lang.plugin_prompts,
    COMPLETE_FILLING = Lang.complete_filling,
    RAIL = Lang.rail,
    PODIUM = Lang.podium,
    ENERGY_LEVEL = Lang.energy_level,
    ENERGY_LEVEL2 = Lang.energy_level2;

var PROMPT = {
    ORI_ERROR: Lang.ori_error,
    MENU_COMMAND: Lang.menu,
    MINE: Lang.mine,
    GAME: Lang.game,
    SERVER: Lang.server,
    THE_END: Lang.the_end,
    TRAITBLOCK: Lang.traitblock,
    SIGN_MENU: Lang.sign_menu,
    SERVER_FILES: Lang.server_files,
    THE_MAIN_CITY: Lang.the_main_city,
    CNMAP: Lang.cnmap,
    COURSE_OF_STUDY: Lang.course_of_study,
    END_LAND: Lang.end_land,
    OTHER_SERVER: Lang.other_server,
    GAMES: Lang.games,
    GO_MINE: Lang.go_mine,
    GO_BACK: Lang.go_back,
    LAND: Lang.land,
    PVP: Lang.pvp,
    PARKOUR: Lang.parkour,
    EMPTY_ISLAND_WAR: Lang.empty_island_war,
    PRIVATE_LAND: Lang.private_land,
    DISPALY_LAND: Lang.display_land,
    RCCBEC: Lang.rccbec,
    RCCBES: Lang.rccbes,
    RCCJEC: Lang.rccjec,
    RCCJES: Lang.rccjes,
    PLUGIN_PROMPTS: Lang.plugin_prompts,
    COMPLETE_FILLING: Lang.complete_filling,
    RAIL: Lang.rail,
    PODIUM: Lang.podium,
    ENERGY_LEVEL: Lang.energy_level,
    ENERGY_LEVEL2: Lang.energy_level2
}

var PLAYTIME = new JsonConfigFile("./plugins/Elysium/config/player_online_time.json");
PLAYTIME.init("player_online_time", []);//初始化玩家在线信息json文件
mc.listen("onServerStarted", function () {
    const cmd = mc.newCommand("menu", `${MENU_COMMAND}`, PermType.Any);//注册真指令
    //打开菜单指令声明
    cmd.setCallback(function (_cmd, ori, out, _res) {
        if (!ori.player) return out.error(ORI_ERROR);
        MENU(ori.player);//指令调用的函数
    });
    cmd.overload([]);
    cmd.setup();

    //监听器，检测玩家使用钟
    mc.listen('onUseItem', (player, item) => {
        if (item.name == "Clock") {
            player.runcmd("menu");
        }
    });
})

//特性讲台生成
mc.listen('onPlaceBlock', (player, block) => {
    if (player.hasTag('讲台add') == true) {
        let pos = block.pos
        for (let i = -1; i <= 15; i++) {
            if (player.hasTag(`讲台${i}`)) {
                mc.runcmdEx(`structure load 讲台${i} ${pos.x} ${pos.y} ${pos.z}`)
            }
        }
        player.removeTag("讲台add")
        for (let i = -1; i <= 15; i++) {
            player.removeTag(`讲台${i}`)
        }
        return false;
    }
});
//特性铁轨生成
mc.listen('onPlaceBlock', (pla, block) => {
    if (pla.hasTag('铁轨') == true) {
        let pos = block.pos
        mc.runcmdEx(`structure load 铁轨 ${pos.x} ${pos.y + 1} ${pos.z}`)
        pla.removeTag("铁轨")
        return false;
    }
});

let load = JSON.parse(PLAYTIME.read());

//调用在线时间保存
setInterval(function () {//重复执行
    let pls = mc.getOnlinePlayers();
    for (let i = 0; i < pls.length; ++i) {
        outTime(pls[i].realName);
    }
}, 60000);

function outTime(name) {
    let player_online_time = PLAYTIME.get("player_online_time");
    let i = 0;
    if (player_online_time[i] == null) {
        player_online_time[i] = {};
        player_online_time[i].name = name;
        player_online_time[i].time = 0;
    }
    let status = false;
    let j = 0;
    for (i in player_online_time) {
        if (player_online_time[i].name == name) {
            player_online_time[i].time = player_online_time[i].time + 1;
            status = true;
        }
        if (player_online_time[j + 1] == null && status == false) {
            player_online_time[j + 1] = {};
            player_online_time[j + 1].name = name;
            player_online_time[j + 1].time = 0;
        }
        j = j + 1;
    }
    PLAYTIME.set("player_online_time", player_online_time);
}

//主菜单表单
function MENU(player) {
    var fm = mc.newSimpleForm();
    fm.setTitle(`${MENU_COMMAND}`);
    fm.addButton(PROMPT.MINE, "textures/ui/icon_steve.png");
    fm.addButton(PROMPT.SIGN_MENU, "textures/ui/dust_selectable_1.png");
    fm.addButton(PROMPT.THE_MAIN_CITY, "textures/ui/permissions_op_crown_hover.png");
    fm.addButton(PROMPT.SERVER_FILES, "textures/ui/addServer.png");
    fm.addButton(PROMPT.CNMAP, "textures/ui/icon_map.png");
    fm.addButton(PROMPT.COURSE_OF_STUDY, "textures/ui/warning_alex.png")
    fm.addButton(PROMPT.END_LAND, "textures/ui/realmsIcon.png");
    fm.addButton(PROMPT.SERVER, "textures/ui/mashup_world.png");
    fm.addButton(PROMPT.GAMES, "textures/ui/icon_multiplayer.png");
    player.sendForm(fm,
        function (pla, data) {
            if (data == 0) {
                { pIM(pla); }
            }
            else if (data == 1) {
                pla.runcmd("sign");//签到菜单跳转
            }
            else if (data == 2) {
                pla.teleport(0, 100, 0, 0);//传送主城
            }
            else if (data == 3) {
                SER(pla);//服务器信息显示
            }
            else if (data == 4) {
                pla.teleport(10244, 139, 10116, 0);//传送到中国地图
            }
            else if (data == 5) {
                pla.teleport(1527.95, 104, 1527.95, 0);//传送教程区 
            }
            else if (data == 6) {
                tEN(pla);//传送大型数电展示地皮 
            }
            else if (data == 7) {
                sIN(pla);//传送其他服务器
            }
            else if (data == 8) {
                lGA(pla);//小游戏路径点传送
            }
        }
    );
}
//发送玩家个人信息表单
function pIM(player) {
    let tmptime = 0,
        player_online_time = PLAYTIME.get("player_online_time"),
        i = 0;
    //寻找自己的数据
    for (i in player_online_time) {
        if (player_online_time[i].name == player.realName) {
            tmptime = player_online_time[i].time;
        }
    }
    let TimeMin = tmptime % 60, //分钟
        TimeHour = Math.floor(tmptime / 60) % 60, //小时
        TimeDay = Math.floor(tmptime / 60 / 24), //天
        DeathMode = player.hasTag("death"),
        PLOS = player.getDevice()
    if (player.hasTag("death") == true) {
        DeathMode = "§a已开启§r"
    } else if (player.hasTag("death") == false) {
        DeathMode = "§4未开启§r"
    } else if (PLOS.os = "UWP") {
        PLOS.os = "WIN"
    }
    var fm = mc.newSimpleForm();//新建表单
    fm.setTitle(`${MINE}`);//拟定表单标题
    fm.setContent("你的名称是§a" + player.name + `\n§r你的在线时长为 §e${TimeDay}§r天 §b${TimeHour}§r小时 §a${TimeMin}§r分钟` + `\n当前是否开启死神模式:${DeathMode}` + `\n你的游玩设备为:` + PLOS.os);
    fm.addButton(PROMPT.TRAITBLOCK, "textures/ui/debug_glyph.png");
    fm.addButton(PROMPT.GO_BACK, "textures/ui/import.png");
    player.sendForm(fm,
        function (pla, data) {
            if (data == 0) {
                traitblock(pla)
            }
            if (data == 1) {
                MENU(pla);
            }
        })
}
//特殊方块
function traitblock(player) {
    var fm = mc.newSimpleForm();
    fm.setTitle(`${TRAITBLOCK}`)
    fm.addButton(`${PODIUM}`)
    fm.addButton(`${RAIL}`)
    fm.addButton(PROMPT.GO_MINE, "textures/ui/import.png")
    player.sendForm(fm,
        function (pla, id) {
            if (id == 0) {
                platform(pla)
            }
            if (id == 1) {
                pla.addTag(`铁轨`)
                pla.tell(`<${PLUGIN_PROMPTS}> ${COMPLETE_FILLING}`, 0)
            }
            if (id == 2) {
                pIM(pla)
            }
        })
}
//常充能讲台
function platform(player) {
    var fm = mc.newCustomForm()
    fm.setTitle(`${PODIUM}`)
    fm.addLabel(`${ENERGY_LEVEL}`)
    fm.addSlider(`${ENERGY_LEVEL2}`, 0, 15)
    player.sendForm(fm,
        function (pla, id) {
            if (id != null) {
                pla.addTag(`讲台${id[1]}`)
                pla.addTag(`讲台add`)
                pla.tell(`<${PLUGIN_PROMPTS}> ${COMPLETE_FILLING}`, 0)
            }
        })
}

function SER(server) {
    var fm = mc.newSimpleForm();//新建表单
    fm.setTitle("服务器信息")//拟定表单列表
    fm.setContent("服务器名称:RCCBE创造服务器\n服务器归属:Redstone Circuit Communication\n服务器开放时间:2023年1月1日")
    fm.addButton(PROMPT.GO_BACK, "textures/ui/import.png");
    server.sendForm(fm,
        function (pla, id) {
            if (id == 0) {
                MENU(pla)
            }
        }
    )
}
//传送到末地指定地点
function tEN(player) {
    var fm = mc.newSimpleForm();//新建表单
    fm.setTitle(`${THE_END}`);//拟定表单列表
    fm.addButton(PROMPT.DISPALY_LAND, "textures/ui/permissions_visitor_hand_hover.png");
    fm.addButton(PROMPT.PRIVATE_LAND, "textures/ui/permissions_member_star_hover.png");
    fm.addButton(PROMPT.GO_BACK, "textures/ui/import.png");
    player.sendForm(fm,
        function (pla, id) {
            if (id == 0) {
                pla.teleport(7, 63, 0, 2);
            }
            else if (id == 1) {
                pla.teleport(500, 70, 500, 2);
            }
            else if (id == 2) {
                MENU(pla);
            }
        }
    );
}
//发送服务器信息表单
function sIN(player) {
    var fm = mc.newSimpleForm();//新建表单
    fm.setTitle(`${SERVER}`);//拟定表单列表
    fm.addButton(PROMPT.RCCBEC, "textures/ui/servers.png");
    fm.addButton(PROMPT.RCCBES, "textures/ui/servers.png");
    fm.addButton(PROMPT.RCCJEC, "textures/ui/servers.png");
    fm.addButton(PROMPT.RCCJES, "textures/ui/servers.png");
    fm.addButton(PROMPT.GO_BACK, "textures/ui/import.png");
    player.sendForm(fm,
        function (pla, id) {
            if (id == 0) {
                pla.transServer("RCC.9666.fun", 20220);
            }
            else if (id == 1) {
                pla.transServer("1024.cnonepoint.com", 11024);
            }
            else if (id == 2) {
                pla.transServer("play.simpfun.cn", 10479);
            }
            else if (id == 3) {
                pla.transServer("play.simpfun.cn", 10480);
            }
            else if (id == 4) {
                MENU(pla);
            }
        }
    );

}
//传送到小游戏地点
function lGA(player) {
    var fm = mc.newSimpleForm();//新建表单
    fm.setTitle(`${GAME}`);//拟定表单列表
    fm.addButton(PROMPT.PVP, "textures/ui/sword.png");
    fm.addButton(PROMPT.PARKOUR, "textures/ui/speed_effect.png");
    fm.addButton(PROMPT.EMPTY_ISLAND_WAR, "textures/ui/icon_recipe_equipment.png");
    fm.addButton(PROMPT.GO_BACK, "textures/ui/import.png");
    player.sendForm(fm,
        function (pla, id) {
            if (id == 0) {
                //传送到PVP
                pla.teleport(1000, 100, 1000, 0);
            }
            else if (id == 1) {
                //传送到跑酷
                pla.teleport(2560, 129, 2657, 0);
            }
            else if (id == 2) {
                //传送到空岛战争
                pla.teleport(2000, 100, 2000, 0);
            }
            else if (id == 3) {
                MENU(pla);
            }
        }
    );
}

