const conf = new JsonConfigFile("./plugins/Elysium/config/config.json")
const config = conf.init("config", {});

let lang = config.语言;

const LANG = new JsonConfigFile(`./plugins/Elysium/Lang/${lang}.json`)
const Lang = LANG.init("LANG", {});

let ORI_ERROR = Lang.ori_error,
    SIGN_MENU = Lang.sign_menu,
    SIGN_COMMAND = Lang.sign_command,
    GO_BACK = Lang.go_back;

var PROMPT = {
    SIGN_MENU: Lang.sign_menu,
    GO_BACK: Lang.go_back,
    SIGN_COMMAND: Lang.sign_command,
}

mc.listen("onServerStarted", function () {
    const sign = mc.newCommand("sign", `${SIGN_COMMAND}`, PermType.Any);//注册真指令
    //打开菜单指令声明
    sign.setCallback(function (_cmd, ori, out, _res) {
        if (!ori.player) return out.error(`${ORI_ERROR}`);
        SIGNMENU(ori.player);
    });
    sign.overload([]);
    sign.setup();
})

var SIGN = new JsonConfigFile("./plugins/Elysium/config/player_sign.json")
SIGN.init("player_sign", []);//初始化玩家在线信息json文件

function SIGNLIST(name) { //@name 要签到的玩家的名字 type String
    let player_sign = SIGN.get("player_sign");
    let n = 0;//数组的序号
    let x = 0;
    let FirstTime = false;//第一次签到
    let ConTime = false;//连续签到
    let ReTime = false;//连续签到
    let In = true;//是否初始化
    for (x in player_sign) { //搜索自己的数据的序号
        if (player_sign[x].name == name) {
            n = x //保存在局部变量n中
            In = false//搜索到数据了取消初始化
            break; //搜索到数据了跳出循环
        }
    }
    if (In == true) {
        player_sign.push(
            {
                "name": `${name}`
            }
        )
        n = player_sign.length - 1
    }
    let SystemTime = system.getTimeObj()//获取系统时间
    if (player_sign[n].Date == undefined) { // 初始化
        player_sign[n].Date = {
            Y: SystemTime.Y, //年
            M: SystemTime.M,//月
            D: SystemTime.D//日
        }
        player_sign[n].time_t = 1//总签到次数
        player_sign[n].time_l = 1//连续签到次数
        player_sign[n].time_j = 0//已经用过的体验卡数量
        // player_sign[n].w_or_n = 0//是否可签到判断 多余的操作
        FirstTime = true // 第一次签到
    } else {
        if (player_sign[n].Date.Y == SystemTime.Y) {
            if (player_sign[n].Date.M == SystemTime.M) {
                if (player_sign[n].Date.D == SystemTime.D) {
                    //今天已经签到过了
                    ReTime = true
                } else if (player_sign[n].Date.D == SystemTime.D - 1) {
                    //连续签到
                    player_sign[n].time_t++;
                    player_sign[n].time_l++;
                    ConTime = true;
                } else {
                    //断签
                    player_sign[n].time_t++;
                    player_sign[n].time_l = 1;
                }
            } else {
                //断签
                player_sign[n].time_t++;
                player_sign[n].time_l = 1;
            }
        } else {
            //断签
            player_sign[n].time_t++;
            player_sign[n].time_l = 1;
        }
        player_sign[n].Date.Y = SystemTime.Y
        player_sign[n].Date.M = SystemTime.M
        player_sign[n].Date.D = SystemTime.D
    }
    if (player_sign[n].time_t % 10 == 0) { //检测进位
        player_sign[n].op++;
        player_sign[n].time_t = 0;
    }
    let Sheet = {
        First: FirstTime, //第一次签到 @Boolean
        Con: ConTime, //连续签到 @Boolean
        Re: ReTime, //重复签到 @Boolean
        t: player_sign[n].time_t,//总签到次数
        l: player_sign[n].time_l,//连续签到次数
        j: player_sign[n].time_j//已经用过的体验卡数量
    }
    SIGN.set("player_sign", player_sign);
    return Sheet;
};

function SIGNMENU(player) {
    let Return = SIGNLIST(player.realName)
    let PLTI = Math.floor(Return.t / 10) - Return.j
    let PLNM = player.name,
        PLLC = player.langCode,
        PLGM = player.gameMode,
        PLos = player.getDevice(),
        DeathMode = player.hasTag("death"),
        PLOS = PLos.os,
        PLAP = PLos.avgPing,
        PLAPL = PLos.avgPacketLoss,
        PLLP = PLos.lastPing,
        PLIM = PLos.inputMode
    switch (DeathMode) {
        case true:
            DeathMode = "§a已开启§r"
            break;
        case false:
            DeathMode = "§4未开启§r"
            break;
    };
    switch (PLOS) {
        case "UWP":
            PLOS = "WIN10"
            break;
        case "Android":
            PLOS = "安卓"
            break;
    };
    switch (PLIM) {
        case 1:
            PLIM = "键鼠"
            break;
        case 2:
            PLIM = "触屏"
            break;
        case 3:
            PLIM = "手柄"
            break;
        case 4:
            PLIM = "运动控制器"
            break;
    }
    switch (PLGM) {
        case 0:
            PLGM = "生存"
            break;
        case 1:
            PLGM = "创造"
            break;
        case 2:
            PLGM = "冒险"
            break;
        case 6:
            PLGM = "旁观者"
    }
    var fm = mc.newSimpleForm();
    fm.setTitle(`${SIGN_MENU}`);
    fm.setContent(`你的id为: §a${PLNM}§r       你的总签到次数为: §a${Return.t}§r 天\n你已连续签到: §6${Return.l} §r天         你可兑换: §3${PLTI} §r次\n§r当前是否开启死神模式: §a${DeathMode}\n§r你设置的语言为: §3${PLLC}\n§r你的游戏模式为: §e${PLGM}\n§r你的游玩设备为: §c${PLOS}\n§r你的网络延迟时间为: §b${PLLP}ms\n§r你的平均网络延迟时间为: §b${PLAP}ms\n§r你的平均网络丢包率为: §a${PLAPL}\n§r你的操作模式为: §6${PLIM}`);
    fm.addButton(PROMPT.SIGN_COMMAND, "textures/ui/dust_selectable_1.png")
    fm.addButton(PROMPT.GO_BACK, "textures/ui/import.png")
    player.sendForm(fm,
        function (pla, data) {
            if (data == 0) {
                if (Return.First == true) {
                    player.tell("§l--------------------------" + "\n§r你的第一次签到!" + "\n§r你的总签到次数为§a" + [Return.t] + "\n§r还差§a" + [10 - (Return.t % 10)] + "§r次就可以找腐竹兑换奖品" + "\n你已可兑换§a" + [Math.floor(Return.t / 10) - Return.j] + "§r次!" + "\n§r你已经连续签到§a " + [Return.l] + " §r天了!" + "\n§l--------------------------");
                } else if (Return.Re == false) {
                    player.tell("§l--------------------------" + "\n§r你的总签到次数为§a" + [Return.t] + "\n§r还差§a" + [10 - (Return.t % 10)] + "§r次就可以找腐竹兑换奖品" + "\n你已可兑换§a" + [Math.floor(Return.t / 10) - Return.j] + "§r次!" + "\n§r你已经连续签到§a " + [Return.l] + " §r天了!" + "\n§l--------------------------");
                } else if (Return.Re == true) {
                    player.tell("你今天已经签到过了!")
                }
            } else if (data == 1) {
                pla.runcmd('menu')
            }
        }
    )
};