const conf = new JsonConfigFile("./plugins/Elysium/config/config.json")
const config = conf.init("config", {});

let lang = config.语言;

const LANG = new JsonConfigFile(`./plugins/Elysium/Lang/${lang}.json`)
const Lang = LANG.init("LANG", {});

let ORI_ERROR = Lang.ori_error,
    THROWSIEVE_BROADCAST1 = Lang.throwsieve_broadcast1,
    THROWSIEVE_BROADCAST2 = Lang.throwsieve_broadcast2,
    THROWSIEVE_COMMAND = Lang.throwsieve_command;

mc.listen("onServerStarted", function () {
    const ThrowSieve = mc.newCommand("throwsieve", `${THROWSIEVE_COMMAND}`, PermType.Any)
    ThrowSieve.setAlias("ts")
    ThrowSieve.setCallback(function (_cmd, ori, out, _res) {
        if (!ori.player) return out.error(ORI_ERROR);
        function getRandomInt(min, max) {
            min = Math.ceil(min);
            max = Math.floor(max);
            return Math.floor(Math.random() * (max - min + 1)) + min;
        }
        let randomInt = getRandomInt(1, 10);
        let player = ori.name;
        mc.broadcast(`§l §c${player} ${THROWSIEVE_BROADCAST1} §a${randomInt} ${THROWSIEVE_BROADCAST2}`, 1)
    });
    ThrowSieve.overload([]);
    ThrowSieve.setup();


})

mc.listen('onUseItem', (player, item) => {
    if (item.name == "Nether Star") {
        player.runcmd('throwsieve')
    }
});
