const conf = new JsonConfigFile("./plugins/Elysium/config/config.json")
const config = conf.init("config", {});

let lang = config.语言;

const LANG = new JsonConfigFile(`./plugins/Elysium/Lang/${lang}.json`)
const Lang = LANG.init("LANG", {});

let GAMETICK = Lang.gametick,
    GAMETICK_SET = Lang.gametick_set,
    GAMETICK_RESET = Lang.gametick_reset;

mc.listen("onServerStarted", () => {
    const TICK = mc.newCommand("tick", `${GAMETICK}`, PermType.GameMasters);
    TICK.setEnum("TickSet", ["set"]);
    TICK.setEnum("Tick", ["reset"]);
    TICK.mandatory("TickSet", ParamType.Enum, "TickSet", 1)
    TICK.mandatory("Tick", ParamType.Enum, "Tick", 1)
    TICK.mandatory("int", ParamType.Int)
    TICK.overload(["Tick"]);
    TICK.overload(["TickSet", "int"]);
    TICK.setCallback((_cmd, ori, out, res) => {
        if (!ori.player) {
            if (res.TickSet) {
                mc.runcmd(`gamerule randomtickspeed ${res.int}`);
                logger.log(`${GAMETICK_SET} ${res.int}`);
            } else if (res.Tick) {
                mc.runcmd(`gamerule randomtickspeed`);
                logger.log(`${GAMETICK_RESET}`);
            }
        } else if (ori.player) {
            if (res.TickSet && ori.player.isOP()) {
                mc.runcmd(`gamerule randomtickspeed ${res.int}`);
                ori.player.tell(`${GAMETICK_SET} ${res.int}`);
            } else if (res.Tick && ori.player.isOP()) {
                mc.runcmd(`gamerule randomtickspeed 1`);
                ori.player.tell(`${GAMETICK_RESET}`);
            }
        }

    });
    TICK.setup();
});
