mc.listen("onServerStarted", function () {
    const TPA = mc.newCommand("tpa", "玩家互传", PermType.Any)
    TPA.optional('name', ParamType.Player)
    TPA.overload(['name']);
    TPA.setCallback(function (cmd, ori, out, res) {
        if (!ori.player) return out.error('此命令仅玩家可使用!');
        if (res.name != undefined) {
            let player2 = res.name[0];
            let player1 = ori.player;
            TPJudge(player1, player2)
        } else if (res.name == undefined) {
            MENU(ori.player)
        }
    });
    TPA.setup();
    const TPAHERE = mc.newCommand("tpahere", "传送玩家至这里", PermType.Any)
    TPAHERE.setCallback(function (cmd, ori, out, res) {
        if (!ori.player) return out.error('此命令仅玩家可使用!');
    });
    const TPACCEPT = mc.newCommand("tpaccept", "接受传送请求", PermType.Any)
    TPACCEPT.setCallback(function (cmd, ori, out, res) {
        if (!ori.player) return out.error('此命令仅玩家可使用!');
        if (ori.player.hasTag(`tpa1`) || ori.player.hasTag(`tpa2`)) {
            let player = mc.getOnlinePlayers()
            let player1 = player.hasTag(`tpa1`)
            let player2 = player.hasTag(`tpa2`)
            mc.runcmd(`tp ${player1} ${player2}`)
            player1.tell(`传送成功`)
            player2.tell(`传送成功`)
            player1.removeTag(`tpa1`)
            player2.removeTag(`tpa2`)
            return
        }
    });
    TPACCEPT.overload([]);
    TPACCEPT.setup();
    const TPACANCEL = mc.newCommand("tpacancel", "取消传送请求", PermType.Any)
    TPACANCEL.setCallback(function (cmd, ori, out, res) {
        if (!ori.player) return out.error('此命令仅玩家可使用!');

    });
})

function TPJudge(player1, player2) {
    if (player2 == undefined) {
        player1.tell(`该玩家不存在`)
    } else if (player2 != undefined) {
        player1.tell(`你向玩家 ${player2.realName} 发送了传送请求 60s后默认拒绝`)
        player2.tell(`玩家 ${player1.realName} 向你发送了传送请求 输入/tpaccept同意 /tpacancel拒绝 或打开菜单选择 60s后默认拒绝`)
        player1.addTag(`tpa1`)
        player2.addTag(`tpa2`)
        function time() {
            player1.tell(`传送请求已过期`)
            player2.tell(`传送请求已过期`)
            player1.removeTag(`tpa1`)
            player2.removeTag(`tpa2`)
        }
        setTimeout(time, 60000);
    }
}

function MENU(player) {
    var fm = mc.newSimpleForm();
    fm.setTitle('TPA主菜单');
    fm.addButton('接受传送');
    fm.addButton('拒绝传送');
    fm.addButton('取消传送');
    fm.addButton('屏蔽传送');
    fm.addButton('互传菜单');
    player.sendForm(fm,
        function (player, data) {
            if (data == 0) {
                player.runcmd(`tpaccept`) //接受传送
            } else if (data == 1) {
                player.runcmd(`tpacancel`) //拒绝传送
            } else if (data == 2) {
                player.runcmd(`tpacancel`) //取消传送
            } else if (data == 3) {
                player.runcmd(`tpacancel`) //屏蔽传送
            } else if (data == 4) {
                TPAMENU(player)
            }
        });
}

function TPAMENU(player) {
    let tpmanner = new Array();
    tpmanner[0] = "§l我传送到TA那里"
    tpmanner[1] = "§lTA传送到我这里"
    var gui = mc.newCustomForm()
    var pls = mc.getOnlinePlayers()
    let players = []
    for (let i = 0; i <= pls.length - 1; i++) {
        players.push(pls[i].realName)
    }
    gui.setTitle(`传送菜单`)
    gui.addDropdown(`选择传送方式`, tpmanner)
    gui.addDropdown(`选择目标玩家`, players)
    player.sendForm(gui, function (pl, data) {
        if (data != undefined, data[1] != null && data[0] != null && players[data[0]] != undefined) {
            if (tpmanner[data[1]] == "§l我传送到TA那里") {
                mc.runcmd(`tp ${pl.realName} ${players[data[0]]}`)
            } else if (tpmanner[data[1]] == "§lTA传送到我这里") {
                mc.runcmd(`tp ${players[data[0]]} ${pl.realName}`)
            }
        }
    })
}