const conf = new JsonConfigFile("./plugins/Elysium/config/config.json")
const config = conf.init("config", {});

let lang = config.语言;

const LANG = new JsonConfigFile(`./plugins/Elysium/Lang/${lang}.json`)
const Lang = LANG.init("LANG", {});

let ORI_ERROR = Lang.ori_error,
    AFK_COMMAND = Lang.afk_command,
    AFK_MSG = Lang.afk_msg,//进入afk状态提示
    UNAFK_MSG = Lang.unafk_msg;//解除afk状态提示

const AfkTime = 10//多少秒触发挂机

var Afk = {}

function PlayerMove(player) {
    mc.broadcast(`§7 ${player.name} ${AFK_MSG}`)
    //这里是移动的玩家
}

function PlayerAfk(player) {
    mc.broadcast(`§7 ${player.name} ${UNAFK_MSG}`)
    //这里是挂机的玩家
}


//进入重置afk状态
mc.listen("onJoin", (player) => {
    Afk[player.realName] = {
        pos: player.pos,
        direction: player.direction,
        time: 0
    };
});

mc.listen("onChat", (player, _msg) => {//发送消息自动接触afk状态
    if (Afk[player.realName].time >= AfkTime) {
        PlayerMove(player);
    }
    Afk[player.realName].time = 0;
});

mc.listen("onServerStarted", () => {
    const AFK = mc.newCommand("afk", `${AFK_COMMAND}`, PermType.Any);
    AFK.setCallback(function (_cmd, ori, out, _res) {
        if (!ori.player) return out.error(ORI_ERROR);
        if (ori.player) {//使用指令进入afk状态
            PlayerMove(ori.player);
        };
    });
    AFK.overload([]);
    AFK.setup();
});

setInterval(() => {
    const Players = mc.getOnlinePlayers();
    let PlayerData = {};

    for (let i in Players) {
        let player = Players[i];
        if (Afk[player.realName]) {
            if (
                (Afk[player.realName].pos.x == player.pos.x)
                && (Afk[player.realName].pos.y == player.pos.y)
                && (Afk[player.realName].pos.z == player.pos.z)
                && (Afk[player.realName].pos.dim == player.pos.dim)
                && (Afk[player.realName].direction.pitch == player.direction.pitch)
                && (Afk[player.realName].direction.yaw == player.direction.yaw)
            ) {
                if (Afk[player.realName].time >= AfkTime) {
                    PlayerAfk(player);
                }
                PlayerData[player.realName] = {
                    pos: player.pos,
                    direction: player.direction,
                    time: Afk[player.realName].time++
                };
            } else {
                if (Afk[player.realName].time >= AfkTime) {
                    PlayerMove(player);
                }
                PlayerData[player.realName] = {
                    pos: player.pos,
                    direction: player.direction,
                    time: 0
                };
            }
        } else {
            PlayerData[player.realName] = {
                pos: player.pos,
                direction: player.direction,
                time: 0
            };
        }
    }
    Afk = PlayerData;
}, 1000);//这里是刷新状态的时间