const conf = new JsonConfigFile("./plugins/Elysium/config/config.json")
const config = conf.init("config", {});

let lang = config.语言;

const LANG = new JsonConfigFile(`./plugins/Elysium/Lang/${lang}.json`)
const Lang = LANG.init("LANG", {});

let ORI_ERROR = Lang.ori_error,
    MODESWITCH_COMMAND = Lang.modeswitch_command,
    ADVENTURE = Lang.adventure,
    CREATIVE = Lang.creative,
    SURVIVAL = Lang.survival,
    SPECTATOR = Lang.spectator;

mc.listen("onServerStarted", () => {
    const mods = mc.newCommand("modeswitch", `${MODESWITCH_COMMAND}`, PermType.Any);
    mods.setAlias("g");
    mods.setEnum("mode", ["s", "c", "a", "p"]);
    mods.mandatory("mode", ParamType.Enum, "mode", 1);
    mods.mandatory("name", ParamType.RawText);
    mods.overload(["mode"]);
    mods.setCallback((_cmd, ori, out, res) => {
        if (!ori.player) return out.error(ORI_ERROR);
        const pl_name = ori.player.name;
        switch (res.mode) {
            case "a":
                mc.runcmd(`gamemode adventure "${pl_name}"`);
                ori.player.tell(`${ADVENTURE}`);
                break;
            case "c":
                mc.runcmd(`gamemode creative "${pl_name}"`);
                ori.player.tell(`${CREATIVE}`);
                break;
            case "s":
                mc.runcmd(`gamemode survival "${pl_name}"`);
                ori.player.tell(`${SURVIVAL}`);
                break;
            case "p":
                mc.runcmd(`gamemode spectator "${pl_name}"`);
                ori.player.tell(`${SPECTATOR}`);
                break;
        }
    });
    mods.setup();
});