const conf = new JsonConfigFile("./plugins/Elysium/config/config.json")
const config = conf.init("config", {});

let lang = config.语言;

const LANG = new JsonConfigFile(`./plugins/Elysium/Lang/${lang}.json`)
const Lang = LANG.init("LANG", {});

let ORI_ERROR = Lang.ori_error,
    NICK_COMMAND = Lang.nick_command,
    RESETNICK = Lang.resetnick,
    SETNICK_ERROR = Lang.setnick_error,
    SETNICK_SUCCESS = Lang.setnick_success,
    UNAFK_MSG = Lang.unafk_msg;

var Info = new JsonConfigFile("./plugins/Elysium/config/player_nick.json")
Info.init("player_nick", []);

mc.listen("onServerStarted", function () {
    const NICK = mc.newCommand("nick", `${NICK_COMMAND}`, PermType.Any)
    NICK.optional("nick", ParamType.String, "nick", 1)
    NICK.overload(["nick"]);
    NICK.setCallback(function (_cmd, ori, out, res) {
        if (!ori.player) return out.error(ORI_ERROR);
        if (res.nick == undefined) {
            setNick(ori.player.realName, ori.player.realName)
            ori.player.tell(`${RESETNICK}`)
        } else if (res.nick != undefined) {
            if (ori.player && res.nick) {
                Return = setNick(ori.player.realName, res.nick)
                if (Return != ori.player.realName) {
                    ori.player.tell(`${SETNICK_SUCCESS}` + Return)
                } else if (Return == ori.player.realName) {
                    ori.player.tell(`${SETNICK_ERROR}`)
                }
            }
        }
    })
    NICK.setup();
})

function setNick(name, nick) {
    const player_nick = Info.get("player_nick");
    let i = 0;
    let seek = false
    for (i in player_nick) {
        if (player_nick[i].name == name) {
            seek = true;
            break;
        }
    }
    if (!seek) {
        player_nick.push({
            "name": `${name}`,
            "nick": `${name}`
        });
    } else {
        if (!player_nick[i].nick) {
            player_nick[i].nick = name;
        }
    }
    if (nick) {
        player_nick[i].nick = nick;
    }
    Info.set("player_nick", player_nick);
    return player_nick[i].nick;
}

mc.listen("onChat", function (player, msg) {
    Return = setNick(player.realName, false)
    mc.broadcast(`<${Return}§r> ` + msg)
    log(`<${Return}§r> ` + msg)
    if (player.hasTag("AFK") == true) {
        player.removeTag("AFK")
        mc.broadcast(` ${player.name} ${UNAFK_MSG}`)
    }
    return false;
})