const conf = new JsonConfigFile("./plugins/Elysium/config/config.json")
const config = conf.init("config", {});

let lang = config.语言;

const LANG = new JsonConfigFile(`./plugins/Elysium/Lang/${lang}.json`)
const Lang = LANG.init("LANG", {});

let ORI_ERROR = Lang.ori_error,
    PLINFO = Lang.player_info,
    OFF = Lang.off,
    ON = Lang.on,
    ANDROID = Lang.android,
    KEYBOARD = Lang.keyboard,
    TOUCH_SCREEN = Lang.touch_screen,
    HANDLE = Lang.handle,
    MOTION_CONTROLLER = Lang.motion_controller,
    ADVENTURE = Lang.adventure2,
    CREATIVE = Lang.creative2,
    SURVIVAL = Lang.survival2,
    SPECTATOR = Lang.spectator2,
    PLAYER_ID = Lang.player_id,
    TURNS_ON_DEATHMODE = Lang.turns_on_deathmode,
    PLAYER_XUID = Lang.player_xuid,
    PLAYER_LANGUAGE = Lang.player_language,
    PLAYER_UUID = Lang.player_uuid,
    PLAYER_GAMEMODE = Lang.player_gamemode,
    PLAYER_IP = Lang.player_ip,
    PLAYER_OS = Lang.player_os,
    PLAYER_AVG_PING = Lang.player_avg_ping,
    PLAYER_AVG_PACKET_LOSS = Lang.player_avg_packet_loss,
    PLAYER_LAST_PING = Lang.player_last_ping,
    PLAYER_INPUT_MODE = Lang.player_input_mode,
    PLAYER_SERVER_ADDRESS = Lang.player_server_address,
    PLAYER_CLIENT_ID = Lang.player_client_id,
    UNIQUEID = Lang.uniqueId;
    
mc.listen("onServerStarted", function () {
    const PI = mc.newCommand("playerinformation", `${PLINFO}`, PermType.Any)
    PI.setAlias("pi");
    PI.setCallback(function (_cmd, ori, out, _res) {
        if (!ori.player) return out.error(ORI_ERROR);
        if (ori) function PLDI(player) {
            let PLNM = player.name,
                PLXD = player.xuid,
                PLLC = player.langCode,
                PLUI = player.uniqueId,
                PLGM = player.gameMode,
                PLID = player.uuid,
                DeathMode = player.hasTag("death"),
                PLos = player.getDevice()
            PLIP = PLos.ip
            PLOS = PLos.os
            PLAP = PLos.avgPing
            PLAPL = PLos.avgPacketLoss
            PLLP = PLos.lastPing
            PLIM = PLos.inputMode
            PLSA = PLos.serverAddress
            PLCI = PLos.clientId
            switch (DeathMode) {
                case true:
                    DeathMode = `${ON}`
                    break;
                case false:
                    DeathMode = `${OFF}`
                    break;
            };
            switch (PLOS) {
                case "UWP":
                    PLOS = "WIN10/11"
                    break;
                case "Android":
                    PLOS = `${ANDROID}`
                    break;
            };
            switch (PLIM) {
                case 1:
                    PLIM = `${KEYBOARD}`
                    break;
                case 2:
                    PLIM = `${TOUCH_SCREEN}`
                    break;
                case 3:
                    PLIM = `${HANDLE}`
                    break;
                case 4:
                    PLIM = `${MOTION_CONTROLLER}`
                    break;
            }
            switch (PLGM) {
                case 0:
                    PLGM = `${SURVIVAL}`
                    break;
                case 1:
                    PLGM = `${CREATIVE}`
                    break;
                case 2:
                    PLGM = `${ADVENTURE}`
                    break;
                case 6:
                    PLGM = `${SPECTATOR}`
            }
            player.tell('-------------------------------')
            player.tell(`${PLAYER_ID} §a${PLNM}`)
            player.tell(`${TURNS_ON_DEATHMODE} §a${DeathMode}`)
            player.tell(`${PLAYER_XUID} §3${PLXD}`)
            player.tell(`${PLAYER_UUID} §3${PLID}`)
            player.tell(`${UNIQUEID} §b${PLUI}`)
            player.tell(`${PLAYER_LANGUAGE} §3${PLLC}`)
            player.tell(`${PLAYER_GAMEMODE} §e${PLGM}`)
            player.tell(`${PLAYER_IP} §3${PLIP}`)
            player.tell(`${PLAYER_OS} §c${PLOS}`)
            player.tell(`${PLAYER_AVG_PING} §b${PLLP}ms`)
            player.tell(`${PLAYER_AVG_PACKET_LOSS} §b${PLAP}ms`)
            player.tell(`${PLAYER_LAST_PING} §a${PLAPL}`)
            player.tell(`${PLAYER_INPUT_MODE}: §6${PLIM}`)
            player.tell(`${PLAYER_SERVER_ADDRESS} §3${PLSA}`)
            player.tell(`${PLAYER_CLIENT_ID} §3${PLCI}`)
            player.tell('-------------------------------')
        }
        PLDI(ori.player);
    })
    PI.overload([]);
    PI.setup();
})