const conf = new JsonConfigFile("./plugins/Elysium/config/config.json")
const config = conf.init("config", {});

let lang = config.语言;

const LANG = new JsonConfigFile(`./plugins/Elysium/Lang/${lang}.json`)
const Lang = LANG.init("LANG", {});

let ORI_ERROR = Lang.ori_error,
    SCALE_COMMAND = Lang.scale_command,
    SCALE_COMMAND_RESET = Lang.scale_command_reset,
    SCALE_COMMAND_SET1 = Lang.scale_command_set1,
    SCALE_COMMAND_SET2 = Lang.scale_command_set2,
    SCALE_COMMAND_ERROR_1 = Lang.scale_command_error_1,
    SCALE_COMMAND_ERROR_2 = Lang.scale_command_error_2;

mc.listen("onServerStarted", function () {
    const scale = mc.newCommand("scale", `${SCALE_COMMAND}`, PermType.Any)
    scale.optional('Int', ParamType.Int, 1)
    scale.overload(['Int']);
    scale.setCallback(function (_cmd, ori, out, res) {
        if (!ori.player) return out.error(ORI_ERROR);
        let player = ori.player;
        if (res.Int == undefined) {
            function scale(player) {
                player.setScale(1);
                player.tell(`${SCALE_COMMAND_RESET}`)
            }
            scale(ori.player);
        } else if (res.Int > 35) {
            player.tell(`${SCALE_COMMAND_ERROR_1}`)
        } else if (res.Int < -2) {
            player.tell(`${SCALE_COMMAND_ERROR_2}`)
        } else if (0 >= res.Int <= 35) {
            let scale = res.Int;
            player.setScale(scale);
            player.tell(`${SCALE_COMMAND_SET1} ${scale} ${SCALE_COMMAND_SET2}！`)
        }

    });
    scale.setup();
})